  MEMBER('email.clw')

  INCLUDE('ABFILE.INC'),ONCE

  MAP
EMAILBC0:DctInit    PROCEDURE
EMAILBC0:DctKill    PROCEDURE
EMAILBC0:FilesInit  PROCEDURE
  END

Hide:Access:address  CLASS(FileManager),TYPE               ! FileManager for address
Init                   PROCEDURE(),DERIVED                 ! Method added to host embed code
Kill                   PROCEDURE(),DERIVED                 ! Method added to host embed code
UseFile                PROCEDURE(BYTE UseType = UseType:Uses),BYTE,PROC,DERIVED ! Method added to host embed code
                     END


Hide:Relate:address  CLASS(RelationManager),TYPE           ! RelationManager for address
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED                 ! Method added to host embed code
                     END


_Hide:Access:address &Hide:Access:address,AUTO,THREAD
_Hide:Relate:address &Hide:Relate:address,AUTO,THREAD


EMAILBC0:DctInit PROCEDURE
  CODE
  _Hide:Access:address &= NEW(Hide:Access:address)
  _Hide:Relate:address &= NEW(Hide:Relate:address)
  Relate:address &= _Hide:Relate:address


EMAILBC0:FilesInit PROCEDURE
  CODE
  _Hide:Relate:address.Init


EMAILBC0:DctKill PROCEDURE
  CODE
  _Hide:Relate:address.Kill
  DISPOSE(_Hide:Relate:address)


Hide:Relate:address.Init PROCEDURE
  CODE
  _Hide:Access:address.Init
  SELF.Init(Access:address,1)


Hide:Access:address.Init PROCEDURE

  CODE
  SELF.Initialized = False
  SELF.Buffer &= ADD:Record
  SELF.FileNameValue = 'address'
  SELF.SetErrors(GlobalErrors)
  SELF.File &= address
  PARENT.Init
  Access:address &= SELF


Hide:Access:address.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:address &= NULL                                   ! File manager has been destroyed to assign null, it is an error to reference this after this point


Hide:Access:address.UseFile PROCEDURE(BYTE UseType = UseType:Uses)

ReturnValue          BYTE,AUTO

  CODE
  IF UseType ~= UseType:Initialize
    SELF.UseFile(UseType:Initialize)                       !Recursive call to ensure initialization takes place
  END
  IF UseType = UseType:Initialize AND ~SELF.Initialized
    SELF.InUseFile = True
    SELF.Init(address,GlobalErrors)
    SELF.Create = 1
    SELF.LockRecover = 10
    SELF.AddKey(ADD:KeyName,'ADD:KeyName',0)
  END
                                                           !SELF.InUseFile will be set to False in PARENT
  ReturnValue = PARENT.UseFile(UseType)
  RETURN ReturnValue


Hide:Relate:address.Kill PROCEDURE

  CODE
  _Hide:Access:address.Kill                                ! Kill the file manager
  PARENT.Kill
  Relate:address &= NULL                                   ! Assign NULL to the RelationManager's FileManager reference, it is an error to reference this after this point
  DISPOSE(_Hide:Access:address)                            ! destroy the file manager

